package logo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;

/*************************************************************************

	Un petit Logo minimal qui devra tre amlior par la suite

				J. Ferber - 1999

				Cours de Deug STPI - Montpellier II

**************************************************************************/

public class SimpleLogo extends JFrame implements ActionListener {


	double convDegGrad = 0.0174533; // la constante de conversion de degres en gradient

	JComponent feuille;

	int x, y;	// les coordonnees de la tortue
	int dir;	// la direction de la tortue
	boolean crayon=true; // par defaut on suppose qu'on dessine
	int coul;


	// la procedure principale
	public static void main(String args[])
	{
		System.out.println( "Logo demarre!" );
		new SimpleLogo();

	}


  	void quitter()
  	{
  		System.exit(0);
  	}


	SimpleLogo()
	{
		super("un logo tout simple");
		getContentPane().setLayout(new BorderLayout(10,10));

		// les primitives (les boutons du haut)
		JPanel p1 = new JPanel(new GridLayout());
		JButton b10 = new JButton("Avancer 50");
		p1.add(b10);
		b10.addActionListener(this);
		JButton b11 = new JButton("Droite 45");
		p1.add(b11);
		b11.addActionListener(this);
		JButton b12 = new JButton("Gauche 45");
		p1.add(b12);
		b12.addActionListener(this);

		JButton b15 = new JButton("LeverCrayon");
		p1.add(b15);
		b15.addActionListener(this);
		JButton b16 = new JButton("BaisserCrayon");
		p1.add(b16);
		b16.addActionListener(this);
		JButton b17 = new JButton("Couleur suiv.");
		p1.add(b17);
		b17.addActionListener(this);
		add(p1,"North");

		// les boutons du bas
		JPanel p2 = new JPanel(new GridLayout());
		JButton b20 = new JButton("Proc1");
		p2.add(b20);
		b20.addActionListener(this);
		JButton b21 = new JButton("Proc2");
		p2.add(b21);
		b21.addActionListener(this);
		JButton b22 = new JButton("Proc3");
		p2.add(b22);
		b22.addActionListener(this);

		JButton b23 = new JButton("Effacer");
		p2.add(b23);
		b23.addActionListener(this);
		JButton b24 = new JButton("Quitter");
		p2.add(b24);
		b24.addActionListener(this);
		add(p2,"South");

		feuille = new Canvas();
		feuille.setSize(500,360);
		add(feuille,"Center");

		// on initialise la position de la tortue
		reset();

		pack();
  		show();
	}


	/** la gestion des actions des boutons */
	public void actionPerformed(ActionEvent e)
	{
        String c = e.getActionCommand();

        // actions des boutons du haut
        if (c.equals("Avancer 50")) avancer(50);
        else if (c.equals("Droite 45"))  droite(45);
        else if (c.equals("Gauche 45"))  gauche(45);
        else if (c.equals("LeverCrayon"))  leverCrayon();
        else if (c.equals("BaisserCrayon"))  baisserCrayon();
        else if (c.equals("Couleur suiv.")) {
			couleur(coul+1);
		}

        // actions des boutons du bas
        else if (c.equals("Proc1"))  proc1();
        else if (c.equals("Proc2")) proc2();
        else if (c.equals("Proc3")) proc3();
        else if (c.equals("Effacer")) effacer();
        else if (c.equals("Quitter")) quitter();
  	}

  	/** les procedures outils */

  	void reset()
  	{	// on initialise la position de la tortue
		x = 250;
		y = 180;
		dir = -90;
		crayon = true;
  	}

  	// efface tout et reinitialise la tortue
  	void effacer()
  	{
  		feuille.repaint();
  		reset();
  	}

  	Color getColor(int c) {
  		switch(c) {
  			case 0: return(Color.black);
  			case 1: return(Color.blue);
  			case 2: return(Color.cyan);
  			case 3: return(Color.darkGray);
  			case 4: return(Color.red);
  			case 5: return(Color.green);
  			case 6: return(Color.lightGray);
  			case 7: return(Color.magenta);
  			case 8: return(Color.orange);
  			case 9: return(Color.gray);
  			case 10: return(Color.pink);
  			case 11: return(Color.yellow);
  			default : return(Color.black);
		}
  	}

	/** les procedures de base de fonctionnement de la tortue */

	// avancer de n pas
	void avancer(int dist)
	{	Graphics g = feuille.getGraphics();

		int newX = (int) Math.round(x+dist*Math.cos(convDegGrad*dir));
		int newY = (int) Math.round(y+dist*Math.sin(convDegGrad*dir));
		if (crayon) {
			g.setColor(getColor(coul));
			g.drawLine(x,y,newX,newY);
		}
		x = newX;
		y = newY;
	}

	// aller  droite
	void droite(int ang)
	{
		dir = (dir + ang) % 360;
	}

	// aller  gauche
	void gauche(int ang)
	{
		dir = (dir - ang) % 360;
	}

	// baisser le crayon pour dessiner
	void baisserCrayon()
	{
		crayon = true;
	}

	// lever le crayon pour ne plus dessiner
	void leverCrayon()
	{
		crayon = false;
	}

	// pour changer de couleur de dessin
	void couleur(int n)
	{
		coul = n % 12;
	}

	/** quelques classiques */

	void carre(int n) {
		for (int i=0;i<4;i++) {
			avancer(100);
			droite(90);
		}
	}

	void poly(int n, int a) {
		for (int j=0;j<a;j++) {
			avancer(n);
			droite(360/a);
		}
	}

	void spiral(int n, int k, int a) {
		for (int i = 0; i < k; i++) {
			couleur(coul+1);
			avancer(n);
			droite(360/a);
			n = n+1;
		}
	}


	/** la procedure Logo qui combine plusieurs commandes..*/
	void proc1()
	{
		carre(100);
	}

	void proc2()
	{
		poly(60,8);
	}

	void proc3()
	{
	  spiral(50,40,6);
	}

}
