
package logo;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

/*************************************************************************

	Un petit Logo minimal qui devra tre amlior par la suite

				J. Ferber - 1999-2001

				Cours de DESS TNI - Montpellier II

	@version 2.0
	@date 25/09/2001

**************************************************************************/

/** La classe Tortue qui se dplace en coordonnes polaires
**/

public class Tortue
{

	double convDegGrad = 0.0174533; // la constante de conversion de degres en gradient


	JPanel feuille;	// la feuille de dessin sur laquelle dessine la tortue


	int x, y;	// les coordonnees de la tortue
	int dir;	// la direction de la tortue
	boolean crayon=true; // par defaut on suppose qu'on dessine
	int coul;


	public Tortue(JPanel f){
		feuille = f;
		reset();
	}

	void reset()
  	{	// on initialise la position de la tortue
		x = 250;
		y = 180;
		dir = -90;
		crayon = true;
  	}

  	Color getColor(int c) {
  		switch(c) {
  			case 0: return(Color.black);
  			case 1: return(Color.blue);
  			case 2: return(Color.cyan);
  			case 3: return(Color.darkGray);
  			case 4: return(Color.red);
  			case 5: return(Color.green);
  			case 6: return(Color.lightGray);
  			case 7: return(Color.magenta);
  			case 8: return(Color.orange);
  			case 9: return(Color.gray);
  			case 10: return(Color.pink);
  			case 11: return(Color.yellow);
  			default : return(Color.black);
		}
  	}

	/** les procedures de base de fonctionnement de la tortue */

	// avancer de n pas
	void avancer(int dist)
	{	Graphics g = feuille.getGraphics();

		int newX = (int) Math.round(x+dist*Math.cos(convDegGrad*dir));
		int newY = (int) Math.round(y+dist*Math.sin(convDegGrad*dir));
		if (crayon) {
			g.setColor(getColor(coul));
			g.drawLine(x,y,newX,newY);
		}
		x = newX;
		y = newY;
	}

	// aller  droite
	void droite(int ang)
	{
		dir = (dir + ang) % 360;
	}

	// aller  gauche
	void gauche(int ang)
	{
		dir = (dir - ang) % 360;
	}

	// baisser le crayon pour dessiner
	void baisserCrayon()
	{
		crayon = true;
	}

	// lever le crayon pour ne plus dessiner
	void leverCrayon()
	{
		crayon = false;
	}

	// pour changer de couleur de dessin
	void couleur(int n)
	{
		coul = n % 12;
	}

	void couleurSuivante() {
	 	couleur(coul+1);
	}

	/** quelques classiques */

	void carre(int n) {
		for (int i=0;i<4;i++) {
			avancer(100);
			droite(90);
		}
	}

	void poly(int n, int a) {
		for (int j=0;j<a;j++) {
			avancer(n);
			droite(360/a);
		}
	}

	void spiral(int n, int k, int a) {
		for (int i = 0; i < k; i++) {
			couleur(coul+1);
			avancer(n);
			droite(360/a);
			n = n+1;
		}
	}
}
